using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Collections;
using System.Security.Policy;
using System.Security;
using System.Security.Permissions;
using System.Reflection;
using System.IO;
using Microsoft.Win32;

namespace InstallAssembly
{
    class InstallAssembly
    {
        static void Main(string[] args)
        {
            CreateCodeGroupByUrl();
        }

        //Sets permission by install url.
        public static void CreateCodeGroupByUrl()
        {
            IEnumerator secUrlLevels = SecurityManager.PolicyHierarchy();
            PolicyLevel policyUrlMachineLevel = null;
            CodeGroup machineUrlCodeGroupRoot = null;
            while (secUrlLevels.MoveNext())
            {
                PolicyLevel level = secUrlLevels.Current as PolicyLevel;
                //Used to check whether the level is Machine Level
                if (level != null && level.Label == "Machine")
                {
                    policyUrlMachineLevel = level;
                    machineUrlCodeGroupRoot = level.RootCodeGroup;
                    break;
                }
            }

            UnionCodeGroup myCodeGroupUrl = new UnionCodeGroup(new UrlMembershipCondition("http://www2.syncfusion.com/TestApplication/TreeViewAdvDemo/*"),
                                             new PolicyStatement(new NamedPermissionSet("FullTrust")));
            //Create a code group with public key as evidence
            myCodeGroupUrl.Description = "Code group grants full trust to all code originating from this group";
            myCodeGroupUrl.Name = "Syncfusion";

            //Add this group to the security level you have chosen
            if (!checkIfExists(machineUrlCodeGroupRoot, myCodeGroupUrl))
                machineUrlCodeGroupRoot.AddChild(myCodeGroupUrl);

            //Save the policy
            SecurityManager.SavePolicyLevel(policyUrlMachineLevel);
        }

        //To check whether the code group is already present.
        public static bool checkIfExists(CodeGroup machineCodeGroupRoot, CodeGroup childGroup)
        {
            bool exists = false;
            foreach (CodeGroup codeGroup in machineCodeGroupRoot.Children)
            {
                if (codeGroup.Name == childGroup.Name)
                {
                    exists = true;
                    break;
                }
            }
            return exists;
        }
    }
}
