using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Collections;
using System.Security.Policy;
using System.Security;
using System.Security.Permissions;
using System.Reflection;
using System.IO;

using Microsoft.Win32;

namespace UnInstallAssembly
{
    class UnInstallAssembly
    {
        static void Main(string[] args)
        {
            RemoveCodeGroup();
        }

        public static void RemoveCodeGroup()
        {
            IEnumerator secLevels = SecurityManager.PolicyHierarchy();
            PolicyLevel policyMachineLevel = null;
            CodeGroup machineCodeGroupRoot = null;
            while (secLevels.MoveNext())
            {
                PolicyLevel level = secLevels.Current as PolicyLevel;
                //used to check whether the level is Machine Level
                if (level != null && level.Label == "Machine")
                {
                    policyMachineLevel = level;
                    machineCodeGroupRoot = level.RootCodeGroup;
                    break;
                }
            }

            //Removes the code group.
            foreach (CodeGroup codeGroup in machineCodeGroupRoot.Children)
            {
                if (codeGroup.Name.StartsWith("Syncfusion"))
                {
                    machineCodeGroupRoot.RemoveChild(codeGroup);
                }
            }

            //Saves the policy.
            SecurityManager.SavePolicyLevel(policyMachineLevel);
        }
    }
}
